import { IResult } from "./node";
import { SuffixIndex } from "./suffixindex";
/** A tiny substring search module
 * https://en.wikipedia.org/wiki/Suffix_tree
 * Can be optimized massively especially for space, but trading size for developer hours.
 */
export declare class SuffixTree {
    private index;
    constructor(json?: {});
    /** Serialize the tree to string */
    toJson(): string;
    /** Builds the qeryable index. */
    buildIndex(): SuffixIndex;
    /** index a sequence of words */
    addSentence(sentence: string, searchResult: IResult): void;
    /** index a single word */
    private addWord;
    /** index ending of a string */
    private addSuffix;
}
